#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './kmyfirewalldocumentinfo.ui'
**
** Created: Thu Jan 31 21:57:12 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "kmyfirewalldocumentinfo.h"

#include <qvariant.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qtextedit.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a KMyFirewallDocumentInfo as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
KMyFirewallDocumentInfo::KMyFirewallDocumentInfo( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "KMyFirewallDocumentInfo" );
    setSizeGripEnabled( TRUE );
    KMyFirewallDocumentInfoLayout = new QGridLayout( this, 1, 1, 11, 6, "KMyFirewallDocumentInfoLayout"); 

    lbl_description = new QLabel( this, "lbl_description" );
    lbl_description->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, lbl_description->sizePolicy().hasHeightForWidth() ) );
    lbl_description->setAlignment( int( QLabel::WordBreak | QLabel::AlignTop ) );

    KMyFirewallDocumentInfoLayout->addWidget( lbl_description, 1, 0 );

    lbl_name = new QLabel( this, "lbl_name" );
    lbl_name->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, lbl_name->sizePolicy().hasHeightForWidth() ) );

    KMyFirewallDocumentInfoLayout->addWidget( lbl_name, 0, 0 );

    txt_name = new QLineEdit( this, "txt_name" );
    txt_name->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)0, 0, 0, txt_name->sizePolicy().hasHeightForWidth() ) );

    KMyFirewallDocumentInfoLayout->addWidget( txt_name, 0, 1 );

    txt_description = new QTextEdit( this, "txt_description" );
    txt_description->setWordWrap( QTextEdit::WidgetWidth );
    txt_description->setReadOnly( FALSE );

    KMyFirewallDocumentInfoLayout->addWidget( txt_description, 1, 1 );

    layout2 = new QHBoxLayout( 0, 0, 6, "layout2"); 

    b_help = new QPushButton( this, "b_help" );
    b_help->setAutoDefault( TRUE );
    layout2->addWidget( b_help );
    Horizontal_Spacing2 = new QSpacerItem( 300, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout2->addItem( Horizontal_Spacing2 );

    b_saveAsTemplate = new QPushButton( this, "b_saveAsTemplate" );
    b_saveAsTemplate->setAutoDefault( TRUE );
    b_saveAsTemplate->setDefault( TRUE );
    layout2->addWidget( b_saveAsTemplate );

    buttonOk = new QPushButton( this, "buttonOk" );
    buttonOk->setAutoDefault( TRUE );
    buttonOk->setDefault( TRUE );
    layout2->addWidget( buttonOk );

    buttonCancel = new QPushButton( this, "buttonCancel" );
    buttonCancel->setAutoDefault( TRUE );
    layout2->addWidget( buttonCancel );

    KMyFirewallDocumentInfoLayout->addMultiCellLayout( layout2, 2, 2, 0, 1 );
    languageChange();
    resize( QSize(681, 491).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( buttonOk, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KMyFirewallDocumentInfo::~KMyFirewallDocumentInfo()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KMyFirewallDocumentInfo::languageChange()
{
    setCaption( tr2i18n( "Document Info" ) );
    lbl_description->setText( tr2i18n( "<b>Ruleset&nbsp;Description:</b>" ) );
    lbl_name->setText( tr2i18n( "<b>Ruleset&nbsp;Name:</b>" ) );
    b_help->setText( tr2i18n( "&Help" ) );
    b_help->setAccel( QKeySequence( tr2i18n( "F1" ) ) );
    b_saveAsTemplate->setText( tr2i18n( "Save as &Template" ) );
    buttonOk->setText( tr2i18n( "&Save" ) );
    buttonCancel->setText( tr2i18n( "&Cancel" ) );
    buttonCancel->setAccel( QKeySequence( QString::null ) );
}

#include "kmyfirewalldocumentinfo.moc"
