#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './kmyfirewallnethostproperties.ui'
**
** Created: Thu Jan 31 21:57:12 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "kmyfirewallnethostproperties.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qtextedit.h>
#include <qframe.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a KMyFirewallNetHostProperties as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KMyFirewallNetHostProperties::KMyFirewallNetHostProperties( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KMyFirewallNetHostProperties" );
    KMyFirewallNetHostPropertiesLayout = new QGridLayout( this, 1, 1, 2, 6, "KMyFirewallNetHostPropertiesLayout"); 

    layout16 = new QVBoxLayout( 0, 0, 6, "layout16"); 

    textLabel1_2_2 = new QLabel( this, "textLabel1_2_2" );
    textLabel1_2_2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel1_2_2->sizePolicy().hasHeightForWidth() ) );
    layout16->addWidget( textLabel1_2_2 );

    m_host_desc = new QTextEdit( this, "m_host_desc" );
    m_host_desc->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)7, 0, 0, m_host_desc->sizePolicy().hasHeightForWidth() ) );
    m_host_desc->setWordWrap( QTextEdit::NoWrap );
    m_host_desc->setReadOnly( TRUE );
    layout16->addWidget( m_host_desc );

    KMyFirewallNetHostPropertiesLayout->addLayout( layout16, 0, 1 );

    layout10 = new QVBoxLayout( 0, 0, 6, "layout10"); 

    m_frameAddress = new QFrame( this, "m_frameAddress" );
    m_frameAddress->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, m_frameAddress->sizePolicy().hasHeightForWidth() ) );
    m_frameAddress->setFrameShape( QFrame::NoFrame );
    m_frameAddress->setFrameShadow( QFrame::Plain );
    layout10->addWidget( m_frameAddress );

    m_gb_host_protocol_option = new QGroupBox( this, "m_gb_host_protocol_option" );
    m_gb_host_protocol_option->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)3, 0, 0, m_gb_host_protocol_option->sizePolicy().hasHeightForWidth() ) );
    m_gb_host_protocol_option->setColumnLayout(0, Qt::Vertical );
    m_gb_host_protocol_option->layout()->setSpacing( 6 );
    m_gb_host_protocol_option->layout()->setMargin( 11 );
    m_gb_host_protocol_optionLayout = new QGridLayout( m_gb_host_protocol_option->layout() );
    m_gb_host_protocol_optionLayout->setAlignment( Qt::AlignTop );

    m_cb_host_log = new QCheckBox( m_gb_host_protocol_option, "m_cb_host_log" );
    m_cb_host_log->setEnabled( TRUE );

    m_gb_host_protocol_optionLayout->addWidget( m_cb_host_log, 2, 0 );

    layout9_2 = new QHBoxLayout( 0, 0, 6, "layout9_2"); 

    m_cb_host_limit = new QCheckBox( m_gb_host_protocol_option, "m_cb_host_limit" );
    layout9_2->addWidget( m_cb_host_limit );

    m_sb_host_rate = new QSpinBox( m_gb_host_protocol_option, "m_sb_host_rate" );
    m_sb_host_rate->setEnabled( FALSE );
    m_sb_host_rate->setMinValue( 1 );
    layout9_2->addWidget( m_sb_host_rate );

    m_lbl_slash = new QLabel( m_gb_host_protocol_option, "m_lbl_slash" );
    m_lbl_slash->setEnabled( FALSE );
    m_lbl_slash->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)1, 0, 0, m_lbl_slash->sizePolicy().hasHeightForWidth() ) );
    layout9_2->addWidget( m_lbl_slash );

    m_cb_limit_host_interval = new QComboBox( FALSE, m_gb_host_protocol_option, "m_cb_limit_host_interval" );
    m_cb_limit_host_interval->setEnabled( FALSE );
    m_cb_limit_host_interval->setEditable( FALSE );
    m_cb_limit_host_interval->setInsertionPolicy( QComboBox::NoInsertion );
    m_cb_limit_host_interval->setDuplicatesEnabled( FALSE );
    layout9_2->addWidget( m_cb_limit_host_interval );

    m_gb_host_protocol_optionLayout->addLayout( layout9_2, 1, 0 );
    layout10->addWidget( m_gb_host_protocol_option );

    KMyFirewallNetHostPropertiesLayout->addLayout( layout10, 0, 0 );
    languageChange();
    resize( QSize(642, 209).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( m_cb_host_limit, SIGNAL( toggled(bool) ), m_sb_host_rate, SLOT( setEnabled(bool) ) );
    connect( m_cb_host_limit, SIGNAL( toggled(bool) ), m_cb_limit_host_interval, SLOT( setEnabled(bool) ) );
    connect( m_cb_host_limit, SIGNAL( toggled(bool) ), m_lbl_slash, SLOT( setEnabled(bool) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KMyFirewallNetHostProperties::~KMyFirewallNetHostProperties()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KMyFirewallNetHostProperties::languageChange()
{
    setCaption( tr2i18n( "Form1" ) );
    textLabel1_2_2->setText( tr2i18n( "Host Documentation:" ) );
    m_gb_host_protocol_option->setTitle( tr2i18n( "Host Options" ) );
    m_cb_host_log->setText( tr2i18n( "Log packets from/for this host" ) );
    m_cb_host_limit->setText( tr2i18n( "Limit matches" ) );
    m_lbl_slash->setText( tr2i18n( "/" ) );
    m_cb_limit_host_interval->clear();
    m_cb_limit_host_interval->insertItem( tr2i18n( "second" ) );
    m_cb_limit_host_interval->insertItem( tr2i18n( "minute" ) );
    m_cb_limit_host_interval->insertItem( tr2i18n( "hour" ) );
}

#include "kmyfirewallnethostproperties.moc"
