#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './kmyfirewallprotocolpropertieswidget.ui'
**
** Created: Thu Jan 31 21:57:12 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "kmyfirewallprotocolpropertieswidget.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a KMyFirewallProtocolPropertiesWidget as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KMyFirewallProtocolPropertiesWidget::KMyFirewallProtocolPropertiesWidget( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KMyFirewallProtocolPropertiesWidget" );
    KMyFirewallProtocolPropertiesWidgetLayout = new QGridLayout( this, 1, 1, 2, 6, "KMyFirewallProtocolPropertiesWidgetLayout"); 

    m_gb_protocol_option = new QGroupBox( this, "m_gb_protocol_option" );
    m_gb_protocol_option->setColumnLayout(0, Qt::Vertical );
    m_gb_protocol_option->layout()->setSpacing( 6 );
    m_gb_protocol_option->layout()->setMargin( 11 );
    m_gb_protocol_optionLayout = new QGridLayout( m_gb_protocol_option->layout() );
    m_gb_protocol_optionLayout->setAlignment( Qt::AlignTop );

    m_cb_log = new QCheckBox( m_gb_protocol_option, "m_cb_log" );
    m_cb_log->setEnabled( TRUE );

    m_gb_protocol_optionLayout->addWidget( m_cb_log, 2, 0 );

    layout9 = new QHBoxLayout( 0, 0, 6, "layout9"); 

    m_cb_limit = new QCheckBox( m_gb_protocol_option, "m_cb_limit" );
    layout9->addWidget( m_cb_limit );

    m_sb_limit_rate = new QSpinBox( m_gb_protocol_option, "m_sb_limit_rate" );
    m_sb_limit_rate->setEnabled( FALSE );
    m_sb_limit_rate->setMinValue( 1 );
    layout9->addWidget( m_sb_limit_rate );

    m_lbl_slash = new QLabel( m_gb_protocol_option, "m_lbl_slash" );
    m_lbl_slash->setEnabled( FALSE );
    m_lbl_slash->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)1, 0, 0, m_lbl_slash->sizePolicy().hasHeightForWidth() ) );
    layout9->addWidget( m_lbl_slash );

    m_cb_limit_interval = new QComboBox( FALSE, m_gb_protocol_option, "m_cb_limit_interval" );
    m_cb_limit_interval->setEnabled( FALSE );
    m_cb_limit_interval->setEditable( FALSE );
    m_cb_limit_interval->setInsertionPolicy( QComboBox::NoInsertion );
    m_cb_limit_interval->setDuplicatesEnabled( FALSE );
    layout9->addWidget( m_cb_limit_interval );

    m_gb_protocol_optionLayout->addLayout( layout9, 1, 0 );

    KMyFirewallProtocolPropertiesWidgetLayout->addWidget( m_gb_protocol_option, 0, 1 );

    m_gb_protocol_description = new QGroupBox( this, "m_gb_protocol_description" );
    m_gb_protocol_description->setColumnLayout(0, Qt::Vertical );
    m_gb_protocol_description->layout()->setSpacing( 6 );
    m_gb_protocol_description->layout()->setMargin( 11 );
    m_gb_protocol_descriptionLayout = new QGridLayout( m_gb_protocol_description->layout() );
    m_gb_protocol_descriptionLayout->setAlignment( Qt::AlignTop );

    m_l_protocol_desc = new QLabel( m_gb_protocol_description, "m_l_protocol_desc" );
    m_l_protocol_desc->setAlignment( int( QLabel::WordBreak | QLabel::AlignTop ) );

    m_gb_protocol_descriptionLayout->addWidget( m_l_protocol_desc, 0, 0 );

    KMyFirewallProtocolPropertiesWidgetLayout->addWidget( m_gb_protocol_description, 0, 0 );
    languageChange();
    resize( QSize(557, 95).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( m_cb_limit, SIGNAL( toggled(bool) ), m_sb_limit_rate, SLOT( setEnabled(bool) ) );
    connect( m_cb_limit, SIGNAL( toggled(bool) ), m_lbl_slash, SLOT( setEnabled(bool) ) );
    connect( m_cb_limit, SIGNAL( toggled(bool) ), m_cb_limit_interval, SLOT( setEnabled(bool) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KMyFirewallProtocolPropertiesWidget::~KMyFirewallProtocolPropertiesWidget()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KMyFirewallProtocolPropertiesWidget::languageChange()
{
    setCaption( tr2i18n( "Form2" ) );
    m_gb_protocol_option->setTitle( tr2i18n( "Protocol Options" ) );
    m_cb_log->setText( tr2i18n( "Log packets maching this protocol" ) );
    m_cb_limit->setText( tr2i18n( "Limit matches" ) );
    m_lbl_slash->setText( tr2i18n( "/" ) );
    m_cb_limit_interval->clear();
    m_cb_limit_interval->insertItem( tr2i18n( "second" ) );
    m_cb_limit_interval->insertItem( tr2i18n( "minute" ) );
    m_cb_limit_interval->insertItem( tr2i18n( "hour" ) );
    m_gb_protocol_description->setTitle( tr2i18n( "Protocol Documentation" ) );
}

#include "kmyfirewallprotocolpropertieswidget.moc"
