#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './kmyfirewallruleeditortargetlog.ui'
**
** Created: Thu Jan 31 21:59:46 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "kmyfirewallruleeditortargetlog.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a KMyFirewallRuleEditorTargetLog as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KMyFirewallRuleEditorTargetLog::KMyFirewallRuleEditorTargetLog( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KMyFirewallRuleEditorTargetLog" );
    KMyFirewallRuleEditorTargetLogLayout = new QVBoxLayout( this, 2, 2, "KMyFirewallRuleEditorTargetLogLayout"); 

    gb_conntrack = new QGroupBox( this, "gb_conntrack" );
    gb_conntrack->setColumnLayout(0, Qt::Vertical );
    gb_conntrack->layout()->setSpacing( 6 );
    gb_conntrack->layout()->setMargin( 11 );
    gb_conntrackLayout = new QVBoxLayout( gb_conntrack->layout() );
    gb_conntrackLayout->setAlignment( Qt::AlignTop );

    Layout9 = new QHBoxLayout( 0, 0, 6, "Layout9"); 

    c_log_prefix = new QCheckBox( gb_conntrack, "c_log_prefix" );
    Layout9->addWidget( c_log_prefix );

    t_log_prefix = new QLineEdit( gb_conntrack, "t_log_prefix" );
    t_log_prefix->setEnabled( FALSE );
    t_log_prefix->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, t_log_prefix->sizePolicy().hasHeightForWidth() ) );
    t_log_prefix->setMaxLength( 29 );
    Layout9->addWidget( t_log_prefix );
    gb_conntrackLayout->addLayout( Layout9 );

    Layout26 = new QHBoxLayout( 0, 0, 6, "Layout26"); 

    c_log_level = new QCheckBox( gb_conntrack, "c_log_level" );
    Layout26->addWidget( c_log_level );

    cb_log_level = new QComboBox( FALSE, gb_conntrack, "cb_log_level" );
    cb_log_level->setEnabled( FALSE );
    cb_log_level->setEditable( FALSE );
    cb_log_level->setInsertionPolicy( QComboBox::NoInsertion );
    cb_log_level->setDuplicatesEnabled( FALSE );
    Layout26->addWidget( cb_log_level );
    gb_conntrackLayout->addLayout( Layout26 );

    c_log_tcp_seq = new QCheckBox( gb_conntrack, "c_log_tcp_seq" );
    gb_conntrackLayout->addWidget( c_log_tcp_seq );

    c_log_tcp_options = new QCheckBox( gb_conntrack, "c_log_tcp_options" );
    gb_conntrackLayout->addWidget( c_log_tcp_options );

    c_log_ip_options = new QCheckBox( gb_conntrack, "c_log_ip_options" );
    gb_conntrackLayout->addWidget( c_log_ip_options );
    KMyFirewallRuleEditorTargetLogLayout->addWidget( gb_conntrack );

    layout22 = new QHBoxLayout( 0, 0, 6, "layout22"); 

    b_ok_2 = new QPushButton( this, "b_ok_2" );
    layout22->addWidget( b_ok_2 );

    b_help = new QPushButton( this, "b_help" );
    layout22->addWidget( b_help );

    b_ok = new QPushButton( this, "b_ok" );
    layout22->addWidget( b_ok );
    KMyFirewallRuleEditorTargetLogLayout->addLayout( layout22 );
    languageChange();
    resize( QSize(263, 221).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( c_log_level, SIGNAL( toggled(bool) ), cb_log_level, SLOT( setEnabled(bool) ) );
    connect( c_log_prefix, SIGNAL( toggled(bool) ), t_log_prefix, SLOT( setEnabled(bool) ) );
    connect( b_help, SIGNAL( clicked() ), this, SLOT( slotHelp() ) );
    connect( b_ok_2, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( b_ok, SIGNAL( clicked() ), this, SLOT( accept() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KMyFirewallRuleEditorTargetLog::~KMyFirewallRuleEditorTargetLog()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KMyFirewallRuleEditorTargetLog::languageChange()
{
    setCaption( tr2i18n( "Logging Options" ) );
    gb_conntrack->setTitle( tr2i18n( "Configure Logging" ) );
    c_log_prefix->setText( tr2i18n( "Set log prefix:" ) );
    t_log_prefix->setText( tr2i18n( "KMyFirewall" ) );
    c_log_level->setText( tr2i18n( "Set log level:" ) );
    cb_log_level->clear();
    cb_log_level->insertItem( tr2i18n( "info" ) );
    cb_log_level->insertItem( tr2i18n( "warning" ) );
    cb_log_level->insertItem( tr2i18n( "notice" ) );
    cb_log_level->insertItem( tr2i18n( "debug" ) );
    cb_log_level->insertItem( tr2i18n( "err" ) );
    cb_log_level->insertItem( tr2i18n( "crit" ) );
    cb_log_level->insertItem( tr2i18n( "alert" ) );
    cb_log_level->insertItem( tr2i18n( "emerg" ) );
    c_log_tcp_seq->setText( tr2i18n( "Log TCP Sequence Numbers" ) );
    c_log_tcp_options->setText( tr2i18n( "Log TCP Options" ) );
    c_log_ip_options->setText( tr2i18n( "Log IP Options" ) );
    b_ok_2->setText( tr2i18n( "&Discard" ) );
    b_help->setText( tr2i18n( "&Help" ) );
    b_ok->setText( tr2i18n( "&Apply" ) );
}

void KMyFirewallRuleEditorTargetLog::slotHelp()
{
    qWarning( "KMyFirewallRuleEditorTargetLog::slotHelp(): Not implemented yet" );
}

void KMyFirewallRuleEditorTargetLog::slotOk()
{
    qWarning( "KMyFirewallRuleEditorTargetLog::slotOk(): Not implemented yet" );
}

void KMyFirewallRuleEditorTargetLog::reject()
{
    qWarning( "KMyFirewallRuleEditorTargetLog::reject(): Not implemented yet" );
}

void KMyFirewallRuleEditorTargetLog::accept()
{
    qWarning( "KMyFirewallRuleEditorTargetLog::accept(): Not implemented yet" );
}

#include "kmyfirewallruleeditortargetlog.moc"
