#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './kmyfirewallruleeditorprotocol.ui'
**
** Created: Thu Jan 31 21:58:58 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "kmyfirewallruleeditorprotocol.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qtabwidget.h>
#include <qframe.h>
#include <qspinbox.h>
#include <qbuttongroup.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a KMyFirewallRuleEditorProtocol as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KMyFirewallRuleEditorProtocol::KMyFirewallRuleEditorProtocol( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KMyFirewallRuleEditorProtocol" );
    KMyFirewallRuleEditorProtocolLayout = new QGridLayout( this, 1, 1, 2, 6, "KMyFirewallRuleEditorProtocolLayout"); 

    l_greeting = new QLabel( this, "l_greeting" );
    l_greeting->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, l_greeting->sizePolicy().hasHeightForWidth() ) );
    l_greeting->setMinimumSize( QSize( 0, 40 ) );
    l_greeting->setMaximumSize( QSize( 32767, 40 ) );
    QFont l_greeting_font(  l_greeting->font() );
    l_greeting_font.setFamily( "Arial" );
    l_greeting_font.setBold( TRUE );
    l_greeting->setFont( l_greeting_font ); 
    l_greeting->setFrameShape( QLabel::StyledPanel );
    l_greeting->setFrameShadow( QLabel::Plain );
    l_greeting->setLineWidth( 2 );
    l_greeting->setAlignment( int( QLabel::WordBreak | QLabel::AlignCenter ) );

    KMyFirewallRuleEditorProtocolLayout->addWidget( l_greeting, 0, 0 );

    gb_protocol = new QGroupBox( this, "gb_protocol" );
    gb_protocol->setEnabled( TRUE );
    gb_protocol->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, gb_protocol->sizePolicy().hasHeightForWidth() ) );
    gb_protocol->setAlignment( int( QGroupBox::WordBreak | QGroupBox::AlignLeft ) );
    gb_protocol->setColumnLayout(0, Qt::Vertical );
    gb_protocol->layout()->setSpacing( 6 );
    gb_protocol->layout()->setMargin( 11 );
    gb_protocolLayout = new QGridLayout( gb_protocol->layout() );
    gb_protocolLayout->setAlignment( Qt::AlignTop );

    c_all = new QCheckBox( gb_protocol, "c_all" );
    c_all->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, c_all->sizePolicy().hasHeightForWidth() ) );

    gb_protocolLayout->addWidget( c_all, 0, 0 );

    c_tcp = new QCheckBox( gb_protocol, "c_tcp" );
    c_tcp->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, c_tcp->sizePolicy().hasHeightForWidth() ) );

    gb_protocolLayout->addWidget( c_tcp, 0, 1 );

    c_inv_prot = new QCheckBox( gb_protocol, "c_inv_prot" );
    c_inv_prot->setEnabled( FALSE );
    c_inv_prot->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, c_inv_prot->sizePolicy().hasHeightForWidth() ) );

    gb_protocolLayout->addWidget( c_inv_prot, 0, 4 );

    c_udp = new QCheckBox( gb_protocol, "c_udp" );
    c_udp->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, c_udp->sizePolicy().hasHeightForWidth() ) );

    gb_protocolLayout->addWidget( c_udp, 0, 2 );

    c_icmp = new QCheckBox( gb_protocol, "c_icmp" );
    c_icmp->setEnabled( TRUE );
    c_icmp->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, c_icmp->sizePolicy().hasHeightForWidth() ) );

    gb_protocolLayout->addWidget( c_icmp, 0, 3 );

    KMyFirewallRuleEditorProtocolLayout->addWidget( gb_protocol, 1, 0 );

    tabWidget = new QTabWidget( this, "tabWidget" );
    tabWidget->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, tabWidget->sizePolicy().hasHeightForWidth() ) );

    tab_ports = new QWidget( tabWidget, "tab_ports" );
    tab_portsLayout = new QGridLayout( tab_ports, 1, 1, 11, 6, "tab_portsLayout"); 

    c_dest_port = new QCheckBox( tab_ports, "c_dest_port" );
    c_dest_port->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, c_dest_port->sizePolicy().hasHeightForWidth() ) );

    tab_portsLayout->addWidget( c_dest_port, 2, 0 );

    c_src_port = new QCheckBox( tab_ports, "c_src_port" );
    c_src_port->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, c_src_port->sizePolicy().hasHeightForWidth() ) );

    tab_portsLayout->addWidget( c_src_port, 1, 0 );

    TextLabel2_2 = new QLabel( tab_ports, "TextLabel2_2" );
    TextLabel2_2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, TextLabel2_2->sizePolicy().hasHeightForWidth() ) );
    TextLabel2_2->setAlignment( int( QLabel::WordBreak | QLabel::AlignTop ) );

    tab_portsLayout->addMultiCellWidget( TextLabel2_2, 0, 0, 0, 1 );
    tabWidget->insertTab( tab_ports, QString::fromLatin1("") );

    tab_multiport = new QWidget( tabWidget, "tab_multiport" );
    tab_multiportLayout = new QGridLayout( tab_multiport, 1, 1, 11, 6, "tab_multiportLayout"); 
    tabWidget->insertTab( tab_multiport, QString::fromLatin1("") );

    tab_special_tcp = new QWidget( tabWidget, "tab_special_tcp" );
    tab_special_tcpLayout = new QGridLayout( tab_special_tcp, 1, 1, 11, 6, "tab_special_tcpLayout"); 

    gb_mask = new QGroupBox( tab_special_tcp, "gb_mask" );
    gb_mask->setEnabled( FALSE );
    gb_mask->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)5, 0, 0, gb_mask->sizePolicy().hasHeightForWidth() ) );
    gb_mask->setColumnLayout(0, Qt::Vertical );
    gb_mask->layout()->setSpacing( 6 );
    gb_mask->layout()->setMargin( 5 );
    gb_maskLayout = new QGridLayout( gb_mask->layout() );
    gb_maskLayout->setAlignment( Qt::AlignTop );

    c_all_mask = new QCheckBox( gb_mask, "c_all_mask" );

    gb_maskLayout->addWidget( c_all_mask, 0, 0 );

    c_none_mask = new QCheckBox( gb_mask, "c_none_mask" );

    gb_maskLayout->addWidget( c_none_mask, 0, 1 );

    c_fin_mask = new QCheckBox( gb_mask, "c_fin_mask" );
    c_fin_mask->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, c_fin_mask->sizePolicy().hasHeightForWidth() ) );

    gb_maskLayout->addWidget( c_fin_mask, 2, 1 );

    c_urg_mask = new QCheckBox( gb_mask, "c_urg_mask" );
    c_urg_mask->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, c_urg_mask->sizePolicy().hasHeightForWidth() ) );

    gb_maskLayout->addWidget( c_urg_mask, 4, 1 );

    c_psh_mask = new QCheckBox( gb_mask, "c_psh_mask" );

    gb_maskLayout->addWidget( c_psh_mask, 4, 0 );

    c_rst_mask = new QCheckBox( gb_mask, "c_rst_mask" );
    c_rst_mask->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, c_rst_mask->sizePolicy().hasHeightForWidth() ) );

    gb_maskLayout->addWidget( c_rst_mask, 3, 1 );

    c_syn_mask = new QCheckBox( gb_mask, "c_syn_mask" );

    gb_maskLayout->addWidget( c_syn_mask, 2, 0 );

    c_ack_mask = new QCheckBox( gb_mask, "c_ack_mask" );

    gb_maskLayout->addWidget( c_ack_mask, 3, 0 );

    Line3 = new QFrame( gb_mask, "Line3" );
    Line3->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, Line3->sizePolicy().hasHeightForWidth() ) );
    Line3->setFrameShape( QFrame::HLine );
    Line3->setFrameShadow( QFrame::Sunken );
    Line3->setFrameShape( QFrame::HLine );

    gb_maskLayout->addMultiCellWidget( Line3, 1, 1, 0, 1 );

    tab_special_tcpLayout->addWidget( gb_mask, 1, 1 );

    gb_comp = new QGroupBox( tab_special_tcp, "gb_comp" );
    gb_comp->setEnabled( FALSE );
    gb_comp->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)5, 0, 0, gb_comp->sizePolicy().hasHeightForWidth() ) );
    gb_comp->setColumnLayout(0, Qt::Vertical );
    gb_comp->layout()->setSpacing( 6 );
    gb_comp->layout()->setMargin( 5 );
    gb_compLayout = new QGridLayout( gb_comp->layout() );
    gb_compLayout->setAlignment( Qt::AlignTop );

    c_all_comp = new QCheckBox( gb_comp, "c_all_comp" );

    gb_compLayout->addWidget( c_all_comp, 0, 0 );

    c_none_comp = new QCheckBox( gb_comp, "c_none_comp" );

    gb_compLayout->addWidget( c_none_comp, 0, 1 );

    Line4 = new QFrame( gb_comp, "Line4" );
    Line4->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, Line4->sizePolicy().hasHeightForWidth() ) );
    Line4->setFrameShape( QFrame::HLine );
    Line4->setFrameShadow( QFrame::Sunken );
    Line4->setFrameShape( QFrame::HLine );

    gb_compLayout->addMultiCellWidget( Line4, 1, 1, 0, 1 );

    c_syn_comp = new QCheckBox( gb_comp, "c_syn_comp" );

    gb_compLayout->addWidget( c_syn_comp, 2, 0 );

    c_fin_comp = new QCheckBox( gb_comp, "c_fin_comp" );
    c_fin_comp->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, c_fin_comp->sizePolicy().hasHeightForWidth() ) );

    gb_compLayout->addWidget( c_fin_comp, 2, 1 );

    c_ack_comp = new QCheckBox( gb_comp, "c_ack_comp" );

    gb_compLayout->addWidget( c_ack_comp, 3, 0 );

    c_rst_comp = new QCheckBox( gb_comp, "c_rst_comp" );
    c_rst_comp->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, c_rst_comp->sizePolicy().hasHeightForWidth() ) );

    gb_compLayout->addWidget( c_rst_comp, 3, 1 );

    c_psh_comp = new QCheckBox( gb_comp, "c_psh_comp" );

    gb_compLayout->addWidget( c_psh_comp, 4, 0 );

    c_urg_comp = new QCheckBox( gb_comp, "c_urg_comp" );
    c_urg_comp->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, c_urg_comp->sizePolicy().hasHeightForWidth() ) );

    gb_compLayout->addWidget( c_urg_comp, 4, 1 );

    tab_special_tcpLayout->addWidget( gb_comp, 1, 2 );

    TextLabel4 = new QLabel( tab_special_tcp, "TextLabel4" );
    TextLabel4->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, TextLabel4->sizePolicy().hasHeightForWidth() ) );
    TextLabel4->setAlignment( int( QLabel::WordBreak | QLabel::AlignTop ) );

    tab_special_tcpLayout->addMultiCellWidget( TextLabel4, 0, 0, 1, 2 );

    layout21 = new QGridLayout( 0, 1, 1, 0, 6, "layout21"); 

    sb_tcp_option_num = new QSpinBox( tab_special_tcp, "sb_tcp_option_num" );
    sb_tcp_option_num->setEnabled( FALSE );
    sb_tcp_option_num->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, sb_tcp_option_num->sizePolicy().hasHeightForWidth() ) );

    layout21->addWidget( sb_tcp_option_num, 3, 0 );

    c_tcp_flags = new QCheckBox( tab_special_tcp, "c_tcp_flags" );
    c_tcp_flags->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, c_tcp_flags->sizePolicy().hasHeightForWidth() ) );

    layout21->addMultiCellWidget( c_tcp_flags, 0, 0, 0, 1 );

    c_inv_flags = new QCheckBox( tab_special_tcp, "c_inv_flags" );
    c_inv_flags->setEnabled( FALSE );
    c_inv_flags->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, c_inv_flags->sizePolicy().hasHeightForWidth() ) );

    layout21->addWidget( c_inv_flags, 1, 1 );

    c_tcp_syn = new QCheckBox( tab_special_tcp, "c_tcp_syn" );
    c_tcp_syn->setEnabled( FALSE );
    c_tcp_syn->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, c_tcp_syn->sizePolicy().hasHeightForWidth() ) );

    layout21->addMultiCellWidget( c_tcp_syn, 4, 4, 0, 1 );

    c_inv_tcp_option = new QCheckBox( tab_special_tcp, "c_inv_tcp_option" );
    c_inv_tcp_option->setEnabled( FALSE );
    c_inv_tcp_option->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, c_inv_tcp_option->sizePolicy().hasHeightForWidth() ) );

    layout21->addWidget( c_inv_tcp_option, 3, 1 );
    Spacer10 = new QSpacerItem( 48, 20, QSizePolicy::Preferred, QSizePolicy::Minimum );
    layout21->addItem( Spacer10, 1, 0 );

    c_inv_syn = new QCheckBox( tab_special_tcp, "c_inv_syn" );
    c_inv_syn->setEnabled( FALSE );
    c_inv_syn->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, c_inv_syn->sizePolicy().hasHeightForWidth() ) );

    layout21->addWidget( c_inv_syn, 5, 1 );

    c_tcp_option = new QCheckBox( tab_special_tcp, "c_tcp_option" );
    c_tcp_option->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, c_tcp_option->sizePolicy().hasHeightForWidth() ) );

    layout21->addMultiCellWidget( c_tcp_option, 2, 2, 0, 1 );
    Spacer12 = new QSpacerItem( 48, 16, QSizePolicy::Preferred, QSizePolicy::Minimum );
    layout21->addItem( Spacer12, 5, 0 );

    tab_special_tcpLayout->addMultiCellLayout( layout21, 0, 1, 0, 0 );
    tabWidget->insertTab( tab_special_tcp, QString::fromLatin1("") );

    tab_icmp = new QWidget( tabWidget, "tab_icmp" );
    tab_icmpLayout = new QGridLayout( tab_icmp, 1, 1, 11, 6, "tab_icmpLayout"); 

    ButtonGroup1 = new QButtonGroup( tab_icmp, "ButtonGroup1" );
    ButtonGroup1->setLineWidth( 0 );
    ButtonGroup1->setColumnLayout(0, Qt::Vertical );
    ButtonGroup1->layout()->setSpacing( 2 );
    ButtonGroup1->layout()->setMargin( 2 );
    ButtonGroup1Layout = new QGridLayout( ButtonGroup1->layout() );
    ButtonGroup1Layout->setAlignment( Qt::AlignTop );

    cb_icmp_type = new QComboBox( FALSE, ButtonGroup1, "cb_icmp_type" );
    cb_icmp_type->setEnabled( FALSE );
    cb_icmp_type->setEditable( TRUE );
    cb_icmp_type->setInsertionPolicy( QComboBox::NoInsertion );
    cb_icmp_type->setDuplicatesEnabled( FALSE );

    ButtonGroup1Layout->addWidget( cb_icmp_type, 0, 1 );

    c_inv_icmp = new QCheckBox( ButtonGroup1, "c_inv_icmp" );
    c_inv_icmp->setEnabled( FALSE );
    c_inv_icmp->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, c_inv_icmp->sizePolicy().hasHeightForWidth() ) );

    ButtonGroup1Layout->addWidget( c_inv_icmp, 1, 0 );

    c_icmp_type = new QCheckBox( ButtonGroup1, "c_icmp_type" );
    c_icmp_type->setEnabled( FALSE );

    ButtonGroup1Layout->addWidget( c_icmp_type, 0, 0 );

    tab_icmpLayout->addWidget( ButtonGroup1, 0, 1 );

    textLabel1 = new QLabel( tab_icmp, "textLabel1" );
    textLabel1->setAlignment( int( QLabel::WordBreak | QLabel::AlignTop ) );

    tab_icmpLayout->addWidget( textLabel1, 0, 0 );
    tabWidget->insertTab( tab_icmp, QString::fromLatin1("") );

    KMyFirewallRuleEditorProtocolLayout->addWidget( tabWidget, 2, 0 );

    layout16 = new QHBoxLayout( 0, 0, 6, "layout16"); 

    b_ok_2 = new QPushButton( this, "b_ok_2" );
    layout16->addWidget( b_ok_2 );
    Spacer3_2_2 = new QSpacerItem( 140, 20, QSizePolicy::Preferred, QSizePolicy::Minimum );
    layout16->addItem( Spacer3_2_2 );

    b_help = new QPushButton( this, "b_help" );
    layout16->addWidget( b_help );
    Spacer3_2 = new QSpacerItem( 140, 20, QSizePolicy::Preferred, QSizePolicy::Minimum );
    layout16->addItem( Spacer3_2 );

    b_ok = new QPushButton( this, "b_ok" );
    layout16->addWidget( b_ok );

    KMyFirewallRuleEditorProtocolLayout->addLayout( layout16, 3, 0 );
    languageChange();
    resize( QSize(527, 458).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( b_help, SIGNAL( clicked() ), this, SLOT( slotHelp() ) );
    connect( b_ok, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( c_tcp_flags, SIGNAL( toggled(bool) ), c_inv_flags, SLOT( setEnabled(bool) ) );
    connect( c_tcp_option, SIGNAL( toggled(bool) ), sb_tcp_option_num, SLOT( setEnabled(bool) ) );
    connect( c_tcp_option, SIGNAL( toggled(bool) ), c_inv_tcp_option, SLOT( setEnabled(bool) ) );
    connect( c_tcp_flags, SIGNAL( toggled(bool) ), gb_mask, SLOT( setEnabled(bool) ) );
    connect( c_tcp_flags, SIGNAL( toggled(bool) ), gb_comp, SLOT( setEnabled(bool) ) );
    connect( c_tcp_syn, SIGNAL( toggled(bool) ), c_inv_syn, SLOT( setEnabled(bool) ) );
    connect( c_icmp_type, SIGNAL( toggled(bool) ), cb_icmp_type, SLOT( setEnabled(bool) ) );
    connect( c_icmp_type, SIGNAL( toggled(bool) ), c_inv_icmp, SLOT( setEnabled(bool) ) );
    connect( c_icmp, SIGNAL( toggled(bool) ), c_icmp_type, SLOT( setEnabled(bool) ) );
    connect( c_udp, SIGNAL( toggled(bool) ), tabWidget, SLOT( setEnabled(bool) ) );
    connect( c_tcp, SIGNAL( toggled(bool) ), tabWidget, SLOT( setEnabled(bool) ) );
    connect( c_all, SIGNAL( toggled(bool) ), c_udp, SLOT( setDisabled(bool) ) );
    connect( c_all, SIGNAL( toggled(bool) ), c_icmp, SLOT( setDisabled(bool) ) );
    connect( c_all, SIGNAL( toggled(bool) ), c_tcp, SLOT( setDisabled(bool) ) );
    connect( c_udp, SIGNAL( toggled(bool) ), c_all, SLOT( setDisabled(bool) ) );
    connect( c_udp, SIGNAL( toggled(bool) ), c_tcp, SLOT( setDisabled(bool) ) );
    connect( c_icmp, SIGNAL( toggled(bool) ), c_tcp, SLOT( setDisabled(bool) ) );
    connect( c_icmp, SIGNAL( toggled(bool) ), c_udp, SLOT( setDisabled(bool) ) );
    connect( c_icmp, SIGNAL( toggled(bool) ), c_all, SLOT( setDisabled(bool) ) );
    connect( c_tcp, SIGNAL( toggled(bool) ), c_icmp, SLOT( setDisabled(bool) ) );
    connect( c_tcp, SIGNAL( toggled(bool) ), c_udp, SLOT( setDisabled(bool) ) );
    connect( c_tcp, SIGNAL( toggled(bool) ), c_all, SLOT( setDisabled(bool) ) );
    connect( c_udp, SIGNAL( toggled(bool) ), c_icmp, SLOT( setDisabled(bool) ) );
    connect( c_none_mask, SIGNAL( toggled(bool) ), c_all_mask, SLOT( setDisabled(bool) ) );
    connect( c_all_mask, SIGNAL( toggled(bool) ), c_none_mask, SLOT( setDisabled(bool) ) );
    connect( c_all_comp, SIGNAL( toggled(bool) ), c_none_comp, SLOT( setDisabled(bool) ) );
    connect( c_none_comp, SIGNAL( toggled(bool) ), c_all_comp, SLOT( setDisabled(bool) ) );
    connect( c_icmp, SIGNAL( toggled(bool) ), ButtonGroup1, SLOT( setEnabled(bool) ) );
    connect( b_ok_2, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( c_icmp, SIGNAL( toggled(bool) ), tabWidget, SLOT( setEnabled(bool) ) );

    // tab order
    setTabOrder( c_all, c_tcp );
    setTabOrder( c_tcp, c_udp );
    setTabOrder( c_udp, c_icmp );
    setTabOrder( c_icmp, c_inv_prot );
    setTabOrder( c_inv_prot, tabWidget );
    setTabOrder( tabWidget, c_tcp_flags );
    setTabOrder( c_tcp_flags, c_tcp_option );
    setTabOrder( c_tcp_option, c_tcp_syn );
    setTabOrder( c_tcp_syn, sb_tcp_option_num );
    setTabOrder( sb_tcp_option_num, c_inv_flags );
    setTabOrder( c_inv_flags, c_inv_tcp_option );
    setTabOrder( c_inv_tcp_option, c_inv_syn );
    setTabOrder( c_inv_syn, c_all_mask );
    setTabOrder( c_all_mask, c_none_mask );
    setTabOrder( c_none_mask, c_syn_mask );
    setTabOrder( c_syn_mask, c_fin_mask );
    setTabOrder( c_fin_mask, c_ack_mask );
    setTabOrder( c_ack_mask, c_rst_mask );
    setTabOrder( c_rst_mask, c_psh_mask );
    setTabOrder( c_psh_mask, c_urg_mask );
    setTabOrder( c_urg_mask, c_all_comp );
    setTabOrder( c_all_comp, c_none_comp );
    setTabOrder( c_none_comp, c_syn_comp );
    setTabOrder( c_syn_comp, c_fin_comp );
    setTabOrder( c_fin_comp, c_ack_comp );
    setTabOrder( c_ack_comp, c_rst_comp );
    setTabOrder( c_rst_comp, c_psh_comp );
    setTabOrder( c_psh_comp, c_urg_comp );
    setTabOrder( c_urg_comp, c_icmp_type );
    setTabOrder( c_icmp_type, cb_icmp_type );
    setTabOrder( cb_icmp_type, c_inv_icmp );
    setTabOrder( c_inv_icmp, b_ok_2 );
    setTabOrder( b_ok_2, b_help );
    setTabOrder( b_help, b_ok );
    setTabOrder( b_ok, c_src_port );
    setTabOrder( c_src_port, c_dest_port );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KMyFirewallRuleEditorProtocol::~KMyFirewallRuleEditorProtocol()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KMyFirewallRuleEditorProtocol::languageChange()
{
    setCaption( tr2i18n( "Protocol Options" ) );
    l_greeting->setText( tr2i18n( "Protocol Options" ) );
    gb_protocol->setTitle( tr2i18n( "Match Protocol" ) );
    c_all->setText( tr2i18n( "ALL" ) );
    c_tcp->setText( tr2i18n( "TCP" ) );
    c_inv_prot->setText( tr2i18n( "Invert Protocol Selection" ) );
    c_udp->setText( tr2i18n( "UDP" ) );
    c_icmp->setText( tr2i18n( "ICMP" ) );
    c_dest_port->setText( tr2i18n( "Destination port" ) );
    c_src_port->setText( tr2i18n( "Source port" ) );
    TextLabel2_2->setText( tr2i18n( "<p>Specifie the ports that should match you rule here.<br>\n"
"You may use a portnumber an inclusive portrange or a service name from <i>/etc/sevices</i> to specifie the port." ) );
    tabWidget->changeTab( tab_ports, tr2i18n( "&Ports && Portranges" ) );
    tabWidget->changeTab( tab_multiport, tr2i18n( "&Multiport Extension" ) );
    gb_mask->setTitle( tr2i18n( "Mask" ) );
    c_all_mask->setText( tr2i18n( "ALL" ) );
    c_none_mask->setText( tr2i18n( "NONE" ) );
    c_fin_mask->setText( tr2i18n( "FIN" ) );
    c_urg_mask->setText( tr2i18n( "URG" ) );
    c_psh_mask->setText( tr2i18n( "PSH" ) );
    c_rst_mask->setText( tr2i18n( "RST" ) );
    c_syn_mask->setText( tr2i18n( "SYN" ) );
    c_ack_mask->setText( tr2i18n( "ACK" ) );
    gb_comp->setTitle( tr2i18n( "Comp" ) );
    c_all_comp->setText( tr2i18n( "ALL" ) );
    c_none_comp->setText( tr2i18n( "NONE" ) );
    c_syn_comp->setText( tr2i18n( "SYN" ) );
    c_fin_comp->setText( tr2i18n( "FIN" ) );
    c_ack_comp->setText( tr2i18n( "ACK" ) );
    c_rst_comp->setText( tr2i18n( "RST" ) );
    c_psh_comp->setText( tr2i18n( "PSH" ) );
    c_urg_comp->setText( tr2i18n( "URG" ) );
    TextLabel4->setText( tr2i18n( "<p>Please make sure that you know what you are doing.<br>\n"
"A misuse of this functionality may result in a hard to detect bug in the firewall.</p>\n"
"" ) );
    c_tcp_flags->setText( tr2i18n( "TCP flags" ) );
    c_inv_flags->setText( tr2i18n( "Invert" ) );
    c_tcp_syn->setText( tr2i18n( "NEW connection." ) );
    c_inv_tcp_option->setText( tr2i18n( "Invert" ) );
    c_inv_syn->setText( tr2i18n( "Invert" ) );
    c_tcp_option->setText( tr2i18n( "TCP option no.:" ) );
    tabWidget->changeTab( tab_special_tcp, tr2i18n( "&Special TCP Options" ) );
    ButtonGroup1->setTitle( QString::null );
    c_inv_icmp->setText( tr2i18n( "Invert ICMP type" ) );
    c_icmp_type->setText( tr2i18n( "Match ICMP type:" ) );
    textLabel1->setText( tr2i18n( "Here you can decide which ICMP Type your rulr should Match." ) );
    tabWidget->changeTab( tab_icmp, tr2i18n( "ICMP" ) );
    b_ok_2->setText( tr2i18n( "&Cancel" ) );
    b_help->setText( tr2i18n( "&Help" ) );
    b_ok->setText( tr2i18n( "&Apply" ) );
}

void KMyFirewallRuleEditorProtocol::slotHelp()
{
    qWarning( "KMyFirewallRuleEditorProtocol::slotHelp(): Not implemented yet" );
}

void KMyFirewallRuleEditorProtocol::accept()
{
    qWarning( "KMyFirewallRuleEditorProtocol::accept(): Not implemented yet" );
}

void KMyFirewallRuleEditorProtocol::reject()
{
    qWarning( "KMyFirewallRuleEditorProtocol::reject(): Not implemented yet" );
}

#include "kmyfirewallruleeditorprotocol.moc"
