#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './kmyfirewallgenericinterfaceicmp.ui'
**
** Created: Thu Jan 31 21:58:17 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "kmyfirewallgenericinterfaceicmp.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a KMyFirewallGenericInterfaceIcmp as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KMyFirewallGenericInterfaceIcmp::KMyFirewallGenericInterfaceIcmp( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KMyFirewallGenericInterfaceIcmp" );
    KMyFirewallGenericInterfaceIcmpLayout = new QGridLayout( this, 1, 1, 2, 2, "KMyFirewallGenericInterfaceIcmpLayout"); 
    spacer3 = new QSpacerItem( 20, 80, QSizePolicy::Minimum, QSizePolicy::Preferred );
    KMyFirewallGenericInterfaceIcmpLayout->addItem( spacer3, 1, 0 );

    GroupBox2_2 = new QGroupBox( this, "GroupBox2_2" );
    GroupBox2_2->setColumnLayout(0, Qt::Vertical );
    GroupBox2_2->layout()->setSpacing( 6 );
    GroupBox2_2->layout()->setMargin( 11 );
    GroupBox2_2Layout = new QGridLayout( GroupBox2_2->layout() );
    GroupBox2_2Layout->setAlignment( Qt::AlignTop );
    spacer4 = new QSpacerItem( 401, 20, QSizePolicy::Preferred, QSizePolicy::Minimum );
    GroupBox2_2Layout->addItem( spacer4, 3, 0 );

    TextLabel3_2_2_2 = new QLabel( GroupBox2_2, "TextLabel3_2_2_2" );
    TextLabel3_2_2_2->setAlignment( int( QLabel::WordBreak | QLabel::AlignVCenter | QLabel::AlignLeft ) );

    GroupBox2_2Layout->addMultiCellWidget( TextLabel3_2_2_2, 2, 2, 0, 1 );

    c_limit_ping = new QCheckBox( GroupBox2_2, "c_limit_ping" );
    c_limit_ping->setChecked( TRUE );

    GroupBox2_2Layout->addWidget( c_limit_ping, 3, 1 );

    c_allow_ping = new QCheckBox( GroupBox2_2, "c_allow_ping" );
    c_allow_ping->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, c_allow_ping->sizePolicy().hasHeightForWidth() ) );
    c_allow_ping->setChecked( TRUE );

    GroupBox2_2Layout->addWidget( c_allow_ping, 1, 1 );
    spacer5 = new QSpacerItem( 381, 20, QSizePolicy::Preferred, QSizePolicy::Minimum );
    GroupBox2_2Layout->addItem( spacer5, 1, 0 );

    TextLabel2_3_2_2 = new QLabel( GroupBox2_2, "TextLabel2_3_2_2" );
    TextLabel2_3_2_2->setTextFormat( QLabel::RichText );
    TextLabel2_3_2_2->setAlignment( int( QLabel::WordBreak | QLabel::AlignVCenter | QLabel::AlignLeft ) );

    GroupBox2_2Layout->addMultiCellWidget( TextLabel2_3_2_2, 0, 0, 0, 1 );

    KMyFirewallGenericInterfaceIcmpLayout->addWidget( GroupBox2_2, 0, 0 );
    languageChange();
    resize( QSize(564, 366).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( c_allow_ping, SIGNAL( toggled(bool) ), c_limit_ping, SLOT( setEnabled(bool) ) );
    connect( c_allow_ping, SIGNAL( toggled(bool) ), TextLabel3_2_2_2, SLOT( setEnabled(bool) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KMyFirewallGenericInterfaceIcmp::~KMyFirewallGenericInterfaceIcmp()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KMyFirewallGenericInterfaceIcmp::languageChange()
{
    setCaption( tr2i18n( "ICMP" ) );
    GroupBox2_2->setTitle( tr2i18n( "ICMP Options" ) );
    TextLabel3_2_2_2->setText( tr2i18n( "<p><b>By limiting the ping requests you allow past your firewall, you can avoid DoS (Denial of Service) attacks.</b><br>\n"
"Those attacks are based on the fact that every computer can only handle a limited number of open connections.\n"
"A DoS attack is mostly performed by a lot of hosts connecting to the victim host until it gives up.</p>" ) );
    c_limit_ping->setText( tr2i18n( "Limit replies " ) );
    c_allow_ping->setText( tr2i18n( "Reply to echo-requests" ) );
    TextLabel2_3_2_2->setText( tr2i18n( "<p>The so-called <b>Ping</b> is an ICMP packet that is sent to a host to check if it's running or not.<br>\n"
"If you disable \"Reply to echo-request\", your computer will be invisible for most of the common programs used to hack/crack hosts on the Internet.<br>\n"
"However, there are a lot of network programs that use ping requests to find and check the connections to their client/server host.</p>" ) );
}

#include "kmyfirewallgenericinterfaceicmp.moc"
