#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './kmyfirewallgenericinterfacelogging.ui'
**
** Created: Thu Jan 31 21:58:17 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "kmyfirewallgenericinterfacelogging.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <krestrictedline.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "krestrictedline.h"

/*
 *  Constructs a KMyFirewallGenericInterfaceLogging as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KMyFirewallGenericInterfaceLogging::KMyFirewallGenericInterfaceLogging( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KMyFirewallGenericInterfaceLogging" );
    KMyFirewallGenericInterfaceLoggingLayout = new QGridLayout( this, 1, 1, 2, 2, "KMyFirewallGenericInterfaceLoggingLayout"); 
    spacer2 = new QSpacerItem( 20, 81, QSizePolicy::Minimum, QSizePolicy::Preferred );
    KMyFirewallGenericInterfaceLoggingLayout->addItem( spacer2, 1, 0 );

    GroupBox3_2 = new QGroupBox( this, "GroupBox3_2" );
    GroupBox3_2->setColumnLayout(0, Qt::Vertical );
    GroupBox3_2->layout()->setSpacing( 6 );
    GroupBox3_2->layout()->setMargin( 11 );
    GroupBox3_2Layout = new QGridLayout( GroupBox3_2->layout() );
    GroupBox3_2Layout->setAlignment( Qt::AlignTop );

    TextLabel1_3 = new QLabel( GroupBox3_2, "TextLabel1_3" );
    TextLabel1_3->setTextFormat( QLabel::RichText );
    TextLabel1_3->setAlignment( int( QLabel::WordBreak | QLabel::AlignVCenter ) );

    GroupBox3_2Layout->addMultiCellWidget( TextLabel1_3, 0, 0, 0, 1 );
    spacer1 = new QSpacerItem( 381, 20, QSizePolicy::Preferred, QSizePolicy::Minimum );
    GroupBox3_2Layout->addItem( spacer1, 1, 0 );

    m_c_log = new QCheckBox( GroupBox3_2, "m_c_log" );
    m_c_log->setChecked( TRUE );

    GroupBox3_2Layout->addWidget( m_c_log, 1, 1 );

    TextLabel5_2_2_2 = new QLabel( GroupBox3_2, "TextLabel5_2_2_2" );
    TextLabel5_2_2_2->setAlignment( int( QLabel::WordBreak | QLabel::AlignTop | QLabel::AlignLeft ) );

    GroupBox3_2Layout->addWidget( TextLabel5_2_2_2, 2, 0 );

    m_le_logPrefix = new KRestrictedLine( GroupBox3_2, "m_le_logPrefix" );
    m_le_logPrefix->setMaxLength( 18 );

    GroupBox3_2Layout->addWidget( m_le_logPrefix, 2, 1 );

    m_c_limitLog = new QCheckBox( GroupBox3_2, "m_c_limitLog" );
    m_c_limitLog->setChecked( TRUE );

    GroupBox3_2Layout->addWidget( m_c_limitLog, 3, 1 );

    TextLabel3_3_2_2_2 = new QLabel( GroupBox3_2, "TextLabel3_3_2_2_2" );
    TextLabel3_3_2_2_2->setAlignment( int( QLabel::WordBreak | QLabel::AlignVCenter | QLabel::AlignLeft ) );

    GroupBox3_2Layout->addWidget( TextLabel3_3_2_2_2, 3, 0 );

    KMyFirewallGenericInterfaceLoggingLayout->addWidget( GroupBox3_2, 0, 0 );
    languageChange();
    resize( QSize(682, 366).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( m_c_log, SIGNAL( toggled(bool) ), m_c_limitLog, SLOT( setEnabled(bool) ) );
    connect( m_c_log, SIGNAL( toggled(bool) ), TextLabel3_3_2_2_2, SLOT( setEnabled(bool) ) );
    connect( m_c_log, SIGNAL( toggled(bool) ), m_le_logPrefix, SLOT( setEnabled(bool) ) );
    connect( m_c_log, SIGNAL( toggled(bool) ), TextLabel5_2_2_2, SLOT( setEnabled(bool) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KMyFirewallGenericInterfaceLogging::~KMyFirewallGenericInterfaceLogging()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KMyFirewallGenericInterfaceLogging::languageChange()
{
    setCaption( tr2i18n( "Logging" ) );
    GroupBox3_2->setTitle( tr2i18n( "Logging" ) );
    TextLabel1_3->setText( tr2i18n( "<p>Logging dropped packets will allow you to have a look at the \n"
"packets (source/destination IP/port, etc.) that tried to pass your \n"
"firewall unsuccessfully.<br>\n"
"This is very useful if any damage has been caused by an attack \n"
"and you want to find the person responsible.<br>\n"
"The entries are written to the system's main log file \n"
"(usually /var/log/messages).<p>" ) );
    m_c_log->setText( tr2i18n( "Log dropped packets" ) );
    TextLabel5_2_2_2->setText( tr2i18n( "<p>The logprefix is a string that is prepended to the lines written to your log file to help you find the lines you need.</p>" ) );
    m_le_logPrefix->setValidChars( tr2i18n( "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ: " ) );
    m_c_limitLog->setText( tr2i18n( "Limit logged packets" ) );
    TextLabel3_3_2_2_2->setText( tr2i18n( "<p>Avoid \"Denial of Service\" attacks by limiting logging.</p>" ) );
}

#include "kmyfirewallgenericinterfacelogging.moc"
