#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './kmyfirewallruleeditor.ui'
**
** Created: Thu Jan 31 21:57:54 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "kmyfirewallruleeditor.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qsplitter.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <kled.h>
#include <qcheckbox.h>
#include <kcombobox.h>
#include <kpushbutton.h>
#include <qcombobox.h>
#include <qwidgetstack.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "kled.h"
#include "kcombobox.h"
#include "kpushbutton.h"

/*
 *  Constructs a KMyFirewallRuleEditor as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KMyFirewallRuleEditor::KMyFirewallRuleEditor( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KMyFirewallRuleEditor" );
    KMyFirewallRuleEditorLayout = new QGridLayout( this, 1, 1, 2, 2, "KMyFirewallRuleEditorLayout"); 

    m_splitter = new QSplitter( this, "m_splitter" );
    m_splitter->setOrientation( QSplitter::Horizontal );

    gb_options = new QGroupBox( m_splitter, "gb_options" );
    gb_options->setEnabled( TRUE );
    gb_options->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, gb_options->sizePolicy().hasHeightForWidth() ) );
    gb_options->setLineWidth( 0 );
    gb_options->setColumnLayout(0, Qt::Vertical );
    gb_options->layout()->setSpacing( 6 );
    gb_options->layout()->setMargin( 2 );
    gb_optionsLayout = new QGridLayout( gb_options->layout() );
    gb_optionsLayout->setAlignment( Qt::AlignTop );

    l_editing_rule = new QLabel( gb_options, "l_editing_rule" );
    l_editing_rule->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignLeft ) );

    gb_optionsLayout->addMultiCellWidget( l_editing_rule, 3, 3, 0, 1 );

    buttonGroup6 = new QButtonGroup( gb_options, "buttonGroup6" );
    buttonGroup6->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, buttonGroup6->sizePolicy().hasHeightForWidth() ) );
    buttonGroup6->setLineWidth( 0 );
    buttonGroup6->setExclusive( TRUE );
    buttonGroup6->setColumnLayout(0, Qt::Vertical );
    buttonGroup6->layout()->setSpacing( 6 );
    buttonGroup6->layout()->setMargin( 0 );
    buttonGroup6Layout = new QHBoxLayout( buttonGroup6->layout() );
    buttonGroup6Layout->setAlignment( Qt::AlignTop );

    rb_filter = new QRadioButton( buttonGroup6, "rb_filter" );
    rb_filter->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, rb_filter->sizePolicy().hasHeightForWidth() ) );
    rb_filter->setChecked( TRUE );
    buttonGroup6Layout->addWidget( rb_filter );

    rb_nat = new QRadioButton( buttonGroup6, "rb_nat" );
    rb_nat->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, rb_nat->sizePolicy().hasHeightForWidth() ) );
    buttonGroup6Layout->addWidget( rb_nat );

    rb_mangle = new QRadioButton( buttonGroup6, "rb_mangle" );
    rb_mangle->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, rb_mangle->sizePolicy().hasHeightForWidth() ) );
    buttonGroup6Layout->addWidget( rb_mangle );

    gb_optionsLayout->addWidget( buttonGroup6, 1, 1 );

    textLabel2 = new QLabel( gb_options, "textLabel2" );
    textLabel2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel2->sizePolicy().hasHeightForWidth() ) );
    textLabel2->setLineWidth( 0 );

    gb_optionsLayout->addWidget( textLabel2, 1, 0 );

    layout14 = new QGridLayout( 0, 1, 1, 0, 6, "layout14"); 

    m_led_modules = new KLed( gb_options, "m_led_modules" );
    m_led_modules->setMinimumSize( QSize( 16, 16 ) );
    m_led_modules->setMaximumSize( QSize( 16, 16 ) );
    m_led_modules->setState( KLed::Off );
    m_led_modules->setLook( KLed::Sunken );
    m_led_modules->setDarkFactor( 600 );

    layout14->addWidget( m_led_modules, 1, 1 );

    textLabel1_2_3_2_2 = new QLabel( gb_options, "textLabel1_2_3_2_2" );
    textLabel1_2_3_2_2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, textLabel1_2_3_2_2->sizePolicy().hasHeightForWidth() ) );

    layout14->addWidget( textLabel1_2_3_2_2, 2, 2 );

    m_led_rp = new KLed( gb_options, "m_led_rp" );
    m_led_rp->setMinimumSize( QSize( 16, 16 ) );
    m_led_rp->setMaximumSize( QSize( 16, 16 ) );
    m_led_rp->setState( KLed::Off );
    m_led_rp->setLook( KLed::Sunken );
    m_led_rp->setDarkFactor( 600 );

    layout14->addWidget( m_led_rp, 1, 3 );

    m_led_fwd = new KLed( gb_options, "m_led_fwd" );
    m_led_fwd->setMinimumSize( QSize( 16, 16 ) );
    m_led_fwd->setMaximumSize( QSize( 16, 16 ) );
    m_led_fwd->setState( KLed::Off );
    m_led_fwd->setLook( KLed::Sunken );
    m_led_fwd->setDarkFactor( 600 );

    layout14->addWidget( m_led_fwd, 2, 1 );

    m_led_martians = new KLed( gb_options, "m_led_martians" );
    m_led_martians->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, m_led_martians->sizePolicy().hasHeightForWidth() ) );
    m_led_martians->setMinimumSize( QSize( 16, 16 ) );
    m_led_martians->setMaximumSize( QSize( 16, 16 ) );
    m_led_martians->setState( KLed::Off );
    m_led_martians->setLook( KLed::Sunken );
    m_led_martians->setDarkFactor( 600 );

    layout14->addWidget( m_led_martians, 2, 3 );

    m_led_syn = new KLed( gb_options, "m_led_syn" );
    m_led_syn->setMinimumSize( QSize( 16, 16 ) );
    m_led_syn->setMaximumSize( QSize( 16, 16 ) );
    m_led_syn->setState( KLed::Off );
    m_led_syn->setLook( KLed::Sunken );
    m_led_syn->setDarkFactor( 600 );

    layout14->addWidget( m_led_syn, 0, 3 );

    textLabel1_2_3_2_2_2 = new QLabel( gb_options, "textLabel1_2_3_2_2_2" );

    layout14->addWidget( textLabel1_2_3_2_2_2, 0, 2 );

    textLabel1_2_2_2 = new QLabel( gb_options, "textLabel1_2_2_2" );

    layout14->addWidget( textLabel1_2_2_2, 1, 2 );

    textLabel1_2_8 = new QLabel( gb_options, "textLabel1_2_8" );

    layout14->addWidget( textLabel1_2_8, 2, 0 );

    textLabel1 = new QLabel( gb_options, "textLabel1" );
    textLabel1->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, textLabel1->sizePolicy().hasHeightForWidth() ) );

    layout14->addMultiCellWidget( textLabel1, 0, 0, 0, 1 );

    textLabel1_2_3_2 = new QLabel( gb_options, "textLabel1_2_3_2" );

    layout14->addWidget( textLabel1_2_3_2, 1, 0 );

    gb_optionsLayout->addMultiCellLayout( layout14, 0, 0, 0, 1 );

    Layout23 = new QHBoxLayout( 0, 0, 6, "Layout23"); 

    TextLabel8 = new QLabel( gb_options, "TextLabel8" );
    TextLabel8->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, TextLabel8->sizePolicy().hasHeightForWidth() ) );
    Layout23->addWidget( TextLabel8 );

    cb_frag = new QCheckBox( gb_options, "cb_frag" );
    cb_frag->setEnabled( FALSE );
    Layout23->addWidget( cb_frag );

    TextLabel9 = new QLabel( gb_options, "TextLabel9" );
    Layout23->addWidget( TextLabel9 );

    cb_frag_inv = new QCheckBox( gb_options, "cb_frag_inv" );
    cb_frag_inv->setEnabled( FALSE );
    Layout23->addWidget( cb_frag_inv );

    gb_optionsLayout->addMultiCellLayout( Layout23, 7, 7, 0, 1 );

    kb_optSelect = new KComboBox( FALSE, gb_options, "kb_optSelect" );
    kb_optSelect->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, kb_optSelect->sizePolicy().hasHeightForWidth() ) );

    gb_optionsLayout->addMultiCellWidget( kb_optSelect, 6, 6, 0, 1 );

    layout12 = new QGridLayout( 0, 1, 1, 0, 6, "layout12"); 

    cb_disable_rule = new QCheckBox( gb_options, "cb_disable_rule" );
    cb_disable_rule->setEnabled( FALSE );
    cb_disable_rule->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, cb_disable_rule->sizePolicy().hasHeightForWidth() ) );

    layout12->addWidget( cb_disable_rule, 0, 1 );

    cb_log_rule = new QCheckBox( gb_options, "cb_log_rule" );
    cb_log_rule->setEnabled( FALSE );
    cb_log_rule->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, cb_log_rule->sizePolicy().hasHeightForWidth() ) );

    layout12->addWidget( cb_log_rule, 1, 1 );

    TextLabel1_2 = new QLabel( gb_options, "TextLabel1_2" );

    layout12->addWidget( TextLabel1_2, 0, 0 );

    TextLabel1_2_2 = new QLabel( gb_options, "TextLabel1_2_2" );

    layout12->addWidget( TextLabel1_2_2, 1, 0 );

    gb_optionsLayout->addMultiCellLayout( layout12, 5, 5, 0, 1 );

    layout20 = new QHBoxLayout( 0, 0, 6, "layout20"); 

    textLabel2_2 = new QLabel( gb_options, "textLabel2_2" );
    layout20->addWidget( textLabel2_2 );

    b_move_up = new KPushButton( gb_options, "b_move_up" );
    b_move_up->setFlat( TRUE );
    layout20->addWidget( b_move_up );

    b_move_down = new KPushButton( gb_options, "b_move_down" );
    b_move_down->setFlat( TRUE );
    layout20->addWidget( b_move_down );

    gb_optionsLayout->addMultiCellLayout( layout20, 4, 4, 0, 1 );

    Layout21 = new QHBoxLayout( 0, 0, 6, "Layout21"); 

    TextLabel10 = new QLabel( gb_options, "TextLabel10" );
    TextLabel10->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)5, 0, 0, TextLabel10->sizePolicy().hasHeightForWidth() ) );
    Layout21->addWidget( TextLabel10 );

    cb_target = new QComboBox( FALSE, gb_options, "cb_target" );
    cb_target->setEnabled( FALSE );
    cb_target->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, cb_target->sizePolicy().hasHeightForWidth() ) );
    cb_target->setAutoResize( TRUE );
    cb_target->setInsertionPolicy( QComboBox::NoInsertion );
    cb_target->setDuplicatesEnabled( FALSE );
    Layout21->addWidget( cb_target );

    gb_optionsLayout->addMultiCellLayout( Layout21, 8, 8, 0, 1 );

    m_ws_target_opt = new QWidgetStack( gb_options, "m_ws_target_opt" );

    page = new QWidget( m_ws_target_opt, "page" );
    m_ws_target_opt->addWidget( page, 0 );

    gb_optionsLayout->addMultiCellWidget( m_ws_target_opt, 9, 9, 0, 1 );

    m_widgetStack = new QWidgetStack( m_splitter, "m_widgetStack" );
    m_widgetStack->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)5, 0, 0, m_widgetStack->sizePolicy().hasHeightForWidth() ) );

    KMyFirewallRuleEditorLayout->addWidget( m_splitter, 0, 0 );
    languageChange();
    resize( QSize(483, 447).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( cb_frag, SIGNAL( clicked() ), this, SLOT( slotFragChanged() ) );
    connect( cb_frag_inv, SIGNAL( clicked() ), this, SLOT( slotFragChanged() ) );
    connect( cb_target, SIGNAL( activated(const QString&) ), this, SLOT( slotTargetChanged(const QString&) ) );
    connect( cb_frag, SIGNAL( toggled(bool) ), cb_frag_inv, SLOT( setEnabled(bool) ) );
    connect( rb_filter, SIGNAL( clicked() ), this, SLOT( slotNewTableSelected() ) );
    connect( rb_nat, SIGNAL( clicked() ), this, SLOT( slotNewTableSelected() ) );
    connect( rb_mangle, SIGNAL( clicked() ), this, SLOT( slotNewTableSelected() ) );
    connect( b_move_down, SIGNAL( clicked() ), this, SLOT( slotMoveRuleDown() ) );
    connect( b_move_up, SIGNAL( clicked() ), this, SLOT( slotMoveRuleUp() ) );

    // tab order
    setTabOrder( rb_filter, cb_disable_rule );
    setTabOrder( cb_disable_rule, cb_log_rule );
    setTabOrder( cb_log_rule, kb_optSelect );
    setTabOrder( kb_optSelect, cb_frag );
    setTabOrder( cb_frag, cb_frag_inv );
    setTabOrder( cb_frag_inv, cb_target );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KMyFirewallRuleEditor::~KMyFirewallRuleEditor()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KMyFirewallRuleEditor::languageChange()
{
    setCaption( tr2i18n( "Rule Editor" ) );
    gb_options->setTitle( QString::null );
    l_editing_rule->setText( tr2i18n( "Editing Rule" ) );
    buttonGroup6->setTitle( QString::null );
    rb_filter->setText( tr2i18n( "filter" ) );
    rb_nat->setText( tr2i18n( "nat" ) );
    rb_mangle->setText( tr2i18n( "mangle" ) );
    textLabel2->setText( tr2i18n( "<b>Table:</b>" ) );
    textLabel1_2_3_2_2->setText( tr2i18n( "Log martians:" ) );
    textLabel1_2_3_2_2_2->setText( tr2i18n( "Syncookies:" ) );
    textLabel1_2_2_2->setText( tr2i18n( "RP-Filter:" ) );
    textLabel1_2_8->setText( tr2i18n( "IP forwarding:" ) );
    textLabel1->setText( tr2i18n( "<b>FW options:</b>" ) );
    textLabel1_2_3_2->setText( tr2i18n( "Load modules:" ) );
    TextLabel8->setText( tr2i18n( "Fragments:" ) );
    cb_frag->setText( QString::null );
    TextLabel9->setText( tr2i18n( "Invert:" ) );
    cb_frag_inv->setText( QString::null );
    cb_disable_rule->setText( QString::null );
    cb_log_rule->setText( QString::null );
    TextLabel1_2->setText( tr2i18n( "Disable rule:" ) );
    TextLabel1_2_2->setText( tr2i18n( "Log matching packets:" ) );
    textLabel2_2->setText( tr2i18n( "Move rule in chain:" ) );
    b_move_up->setText( QString::null );
    b_move_down->setText( QString::null );
    TextLabel10->setText( tr2i18n( "Target:" ) );
}

void KMyFirewallRuleEditor::slotAddRule()
{
    qWarning( "KMyFirewallRuleEditor::slotAddRule(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotDelRule()
{
    qWarning( "KMyFirewallRuleEditor::slotDelRule(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotEditIPopt()
{
    qWarning( "KMyFirewallRuleEditor::slotEditIPopt(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotEditIntOpt()
{
    qWarning( "KMyFirewallRuleEditor::slotEditIntOpt(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotEditLimitOpt()
{
    qWarning( "KMyFirewallRuleEditor::slotEditLimitOpt(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotEditMacOpt()
{
    qWarning( "KMyFirewallRuleEditor::slotEditMacOpt(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotEditProtOpt()
{
    qWarning( "KMyFirewallRuleEditor::slotEditProtOpt(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotEditRule()
{
    qWarning( "KMyFirewallRuleEditor::slotEditRule(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotEditStateOpt()
{
    qWarning( "KMyFirewallRuleEditor::slotEditStateOpt(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotEditTargetOpt()
{
    qWarning( "KMyFirewallRuleEditor::slotEditTargetOpt(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotEditTargetOption()
{
    qWarning( "KMyFirewallRuleEditor::slotEditTargetOption(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotEditTosOpt()
{
    qWarning( "KMyFirewallRuleEditor::slotEditTosOpt(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotFragChanged()
{
    qWarning( "KMyFirewallRuleEditor::slotFragChanged(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotHelp()
{
    qWarning( "KMyFirewallRuleEditor::slotHelp(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotMoveRuleDown()
{
    qWarning( "KMyFirewallRuleEditor::slotMoveRuleDown(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotMoveRuleUp()
{
    qWarning( "KMyFirewallRuleEditor::slotMoveRuleUp(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotNewChainSelected(int)
{
    qWarning( "KMyFirewallRuleEditor::slotNewChainSelected(int): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotNewTableSelected()
{
    qWarning( "KMyFirewallRuleEditor::slotNewTableSelected(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotSaveConfig()
{
    qWarning( "KMyFirewallRuleEditor::slotSaveConfig(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotSaveRuleChanges()
{
    qWarning( "KMyFirewallRuleEditor::slotSaveRuleChanges(): Not implemented yet" );
}

void KMyFirewallRuleEditor::slotTargetChanged(const QString&)
{
    qWarning( "KMyFirewallRuleEditor::slotTargetChanged(const QString&): Not implemented yet" );
}

void KMyFirewallRuleEditor::accept()
{
    qWarning( "KMyFirewallRuleEditor::accept(): Not implemented yet" );
}

void KMyFirewallRuleEditor::reject()
{
    qWarning( "KMyFirewallRuleEditor::reject(): Not implemented yet" );
}

#include "kmyfirewallruleeditor.moc"
