#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './kmyfirewallmultiportwidget.ui'
**
** Created: Thu Jan 31 21:57:12 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "kmyfirewallmultiportwidget.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qlistbox.h>
#include <qspinbox.h>
#include <qlabel.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "qwidget.h"

/*
 *  Constructs a KMyFirewallMultiPortWidget as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KMyFirewallMultiPortWidget::KMyFirewallMultiPortWidget( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KMyFirewallMultiPortWidget" );
    KMyFirewallMultiPortWidgetLayout = new QGridLayout( this, 1, 1, 2, 2, "KMyFirewallMultiPortWidgetLayout"); 

    lb_ports = new QListBox( this, "lb_ports" );
    lb_ports->setEnabled( FALSE );
    lb_ports->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)4, (QSizePolicy::SizeType)7, 0, 0, lb_ports->sizePolicy().hasHeightForWidth() ) );

    KMyFirewallMultiPortWidgetLayout->addMultiCellWidget( lb_ports, 0, 3, 3, 3 );

    b_remove = new QPushButton( this, "b_remove" );
    b_remove->setEnabled( FALSE );

    KMyFirewallMultiPortWidgetLayout->addWidget( b_remove, 3, 2 );

    b_add = new QPushButton( this, "b_add" );
    b_add->setEnabled( FALSE );

    KMyFirewallMultiPortWidgetLayout->addWidget( b_add, 3, 1 );

    sb_port = new QSpinBox( this, "sb_port" );
    sb_port->setEnabled( FALSE );
    sb_port->setMaxValue( 65335 );
    sb_port->setMinValue( 1 );

    KMyFirewallMultiPortWidgetLayout->addWidget( sb_port, 2, 2 );

    TextLabel3 = new QLabel( this, "TextLabel3" );
    TextLabel3->setEnabled( FALSE );
    TextLabel3->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, TextLabel3->sizePolicy().hasHeightForWidth() ) );

    KMyFirewallMultiPortWidgetLayout->addWidget( TextLabel3, 2, 1 );

    ButtonGroup1 = new QButtonGroup( this, "ButtonGroup1" );
    ButtonGroup1->setEnabled( FALSE );
    ButtonGroup1->setLineWidth( 1 );
    ButtonGroup1->setExclusive( TRUE );
    ButtonGroup1->setColumnLayout(0, Qt::Vertical );
    ButtonGroup1->layout()->setSpacing( 6 );
    ButtonGroup1->layout()->setMargin( 11 );
    ButtonGroup1Layout = new QGridLayout( ButtonGroup1->layout() );
    ButtonGroup1Layout->setAlignment( Qt::AlignTop );

    rb_equ = new QRadioButton( ButtonGroup1, "rb_equ" );

    ButtonGroup1Layout->addWidget( rb_equ, 2, 0 );

    rb_dest = new QRadioButton( ButtonGroup1, "rb_dest" );

    ButtonGroup1Layout->addWidget( rb_dest, 1, 0 );

    rb_src = new QRadioButton( ButtonGroup1, "rb_src" );
    rb_src->setChecked( TRUE );

    ButtonGroup1Layout->addWidget( rb_src, 0, 0 );

    KMyFirewallMultiPortWidgetLayout->addMultiCellWidget( ButtonGroup1, 0, 1, 1, 2 );

    TextLabel1 = new QLabel( this, "TextLabel1" );
    TextLabel1->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)5, 0, 0, TextLabel1->sizePolicy().hasHeightForWidth() ) );
    TextLabel1->setAlignment( int( QLabel::WordBreak | QLabel::AlignTop ) );

    KMyFirewallMultiPortWidgetLayout->addMultiCellWidget( TextLabel1, 1, 3, 0, 0 );

    c_use_multiport = new QCheckBox( this, "c_use_multiport" );

    KMyFirewallMultiPortWidgetLayout->addWidget( c_use_multiport, 0, 0 );
    languageChange();
    resize( QSize(625, 190).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( c_use_multiport, SIGNAL( toggled(bool) ), ButtonGroup1, SLOT( setEnabled(bool) ) );
    connect( c_use_multiport, SIGNAL( toggled(bool) ), lb_ports, SLOT( setEnabled(bool) ) );
    connect( c_use_multiport, SIGNAL( toggled(bool) ), TextLabel3, SLOT( setEnabled(bool) ) );
    connect( c_use_multiport, SIGNAL( toggled(bool) ), sb_port, SLOT( setEnabled(bool) ) );
    connect( c_use_multiport, SIGNAL( toggled(bool) ), b_add, SLOT( setEnabled(bool) ) );
    connect( c_use_multiport, SIGNAL( toggled(bool) ), b_remove, SLOT( setEnabled(bool) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KMyFirewallMultiPortWidget::~KMyFirewallMultiPortWidget()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KMyFirewallMultiPortWidget::languageChange()
{
    setCaption( tr2i18n( "MultiPortWidget" ) );
    b_remove->setText( tr2i18n( "&Remove" ) );
    b_add->setText( tr2i18n( "&Add" ) );
    TextLabel3->setText( tr2i18n( "Port:" ) );
    ButtonGroup1->setTitle( QString::null );
    rb_equ->setText( tr2i18n( "Equal ports" ) );
    rb_dest->setText( tr2i18n( "Destination ports" ) );
    rb_src->setText( tr2i18n( "Source ports" ) );
    TextLabel1->setText( tr2i18n( "<p>You may filter for up to 15 ports within one rule if you are using the multiport extention.<br>\n"
"Use this to avoid too large (slow) rulesets." ) );
    c_use_multiport->setText( tr2i18n( "Use multiport extention" ) );
}

#include "kmyfirewallmultiportwidget.moc"
